<template>
    <div class="post">
        <h2>{{ title }}</h2>
        <div>
            <div v-html="content" />
        </div>
        <div class="author">autor: {{ userEmail }} </div>
        <div class="created">
            {{ created.toLocaleDateString() }},
            {{ created.toLocaleTimeString() }}
        </div>
        <div class="rate-wrapper">
            <el-icon @click="positivePost">
                <Plus />
            </el-icon>
            <el-icon @click="negativePost">
                <Minus />
            </el-icon>
        </div>
        <div v-if="typeof user.email !== 'undefined'" class="add-comment-wrapper">
            <el-input v-model="commentContent" placeholder="Comment" />
            <el-tooltip class="box-item" effect="dark" content="Add comment"
                placement="top-start">
                <el-button @click="addComment" class="add-comment-button" type="success" :icon="DArrowRight" circle />
            </el-tooltip>
        </div>
        <CommentComponent v-for="(comment, index) in comments" :key="index" :id="comment.id" :content="comment.content"
            :username="comment.userName" />
    </div>
</template>
<script  lang="ts" setup>

import { ref, Ref, onMounted } from 'vue';
import axios, { AxiosResponse } from 'axios';
import { DArrowRight, Plus, Minus } from "@element-plus/icons-vue";

import Comment from '../interfaces/Comment'
import { useStore } from '../stores';
import { storeToRefs } from 'pinia';

import CommentComponent from './Comment.vue';

interface Props {
    title: string
    content: string,
    created: Date,
    userEmail: string,
    id: number
}


const store = useStore();
const { user } = storeToRefs(store);
const props = defineProps<Props>()
const commentContent: Ref<String> = ref('');
const comments: Ref<Comment[]> = ref([]);

onMounted(() => {
    getComments();
});

function addComment() {
    // @ts-ignore
    axios.post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/comment/post/${props.id}`, {
        content: commentContent.value,
        uuid: user.value.uuid
    }).then((response: AxiosResponse<Comment>) => {
        commentContent.value = '';
        getComments();
    }).catch(err => {
        console.error(err);
    });
}

function getComments() {
    // @ts-ignore
    axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/comment/post/${props.id}`)
        .then(( response: AxiosResponse<Comment[]> ) => {
            comments.value = response.data;
        }).catch(err => {
            console.error(err);
        })
};

function positivePost() {
    // @ts-ignore
    axios.put(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/positive/${props.id}`,
        { uuid: user.value.uuid }
    )
        .then(({ data }) => {

        }).catch(err => {
            console.error(err);
        })
};

function negativePost() {
    // @ts-ignore
    axios.put(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/negative/${props.id}`,
        { uuid: user.value.uuid }
    )
        .then(({ data }) => {
        }).catch(err => {
            console.error(err);
        })
};
</script>
<style scoped lang="scss">
.post {
    border: 1px solid rgba(10, 10, 10, .1);
    padding: 10px;
    margin: 10px;

    .author,
    .created {
        text-align: right;
    }

    .add-comment {
        &>a {
            cursor: pointer;
        }
    }

    .add-comment-wrapper {
        display: flex;
        justify-content: right;

        .add-comment-button {
            left: 20px;
        }
    }
}</style>